#!/usr/bin/env python
# -*- coding: cp1252 -*-

##### V2.4 TEST Septembre 2012 Henrique Rodas

##### Ce script transforme pour PI, les CTX format PII
##### Il traite tous les fichiers des rpertoires et sous rpertoires.
##### Il parcourt tous les ctx sans distinction mais ne traite que les ctx au format PII.
##### Incorporation du nettoyeur de caractres.py (pour les ctx cette fois-ci).
##### Il ouvre tous les rpertoires d'une arborescence.
##### Amlioration ralise : il intgre les LIENS EXTERNES mais pas encore REF_HEURE qui reste coince  00:00.


##### Amlioration importantes  raliser : limiter la longueur des champs pour viter les retours chariots intempestifs.
##### Amlioration importantes  raliser : Pour le moment le champ date est limite  jj/mm/aaaa et n'inclus pas la suite : 00:00:00.
##### Amlioration importantes  raliser : Intgrer REF_HEURE qui reste pour le moment coince  00:00.


import os , string, glob, re, os.path


LPONC=["."," ",",",";","!" , "?" ,":" ,"'","(" , ")" ,"[" ,"]",'\n' ]   



# on dfinit la liste des signes de ponctuation

Liste_des_caracteres = [ ("'", 'une apostrophe',chr(145),chr(146),chr(96),chr(180),"' ", " '", '&apos;'),('"','un guillemet',chr(147), chr(148), chr(171),chr(186),chr(187)),("d' ",'un d apostrophe',"d'"),("l' ",'un l apostrophe',"l'"),
                         ('-', 'un tiret',chr(149),chr(150),chr(151),chr(173),chr(183),'"','•'),('.','un point', ' .'), (',','une virgule', ' ,'),(' ','un espace',chr(160),'  '),('\n','un retour de ligne',chr(12)),('...','des points de suspension',chr(133)),('oe','un oe',chr(156),'"')]

# Dans cette liste de n-uplets :
# l'lment en position 1 est la forme qui va remplacer les formes suivantes
# le deuxime lment est utilis comme commentaire dans la boucle
# on limine ainsi les tirets cadratins, les guillemets simples ( l'anglaise) et autres guillemets typographiques


Liste_des_balises =['<i>','</i>','*','???','<strong>','</strong>','<tr>','</tr>','&lt;i&gt;','&lt;/i&gt;','&lt;/strong&gt;','&lt;strong&gt;','']
Liste_des_accents_html=[('','é'),('','\''),('','â'),('','"'),('','u'),('','ù'),('A','À'),('','è'),('E','É'),('E','Ê'),('','ï'),('-','oe'),('','ë'),('','ç'),('','î'),('','ê'),('',''),("'","’"),("'",'&rsquo;'),("...","&#x2026;"),("'",'&#8217;')]
Liste_des_marqueurs_genre=[(' -e-s','-e-s'),(' (e) ','(e)')]

# Dans cette liste de couples :
# l'lment en position 1 est la forme qui va remplacer la forme suivante


def get_alterations (formes):
    LRES = []
    for p1 in LPONC :
        for p2 in LPONC :
            f = p1 + formes + p2
            LRES.append ( f )

    return LRES

def alterationsfinales (formes):
    LRES = []
    for p2 in LPONC :
        f = formes + p2
        LRES.append ( f )
    return LRES

def alterationsinitiales (formes):
    LRES = []
    for p1 in LPONC :
        f = p1+formes
        LRES.append ( f )

    return LRES

def recode ( name ) :

    F = open (name , "r")
    txt = F.read()
    F.close()
    flag = 0

    for tuplet in Liste_des_caracteres :
        # tester la prsence des formes incorrectes

        
        forme_correcte = tuplet [0]
        formes_incorrectes = tuplet[2:]
        commentaire=tuplet[1]

        #le commentaire s'affichera dans la fentre de commande
        
        for forme in formes_incorrectes:
            if string.find (txt , forme ) != -1:
                flag=1
                txt = string.replace( txt , forme, forme_correcte)
                print ('J\'ai trouv %s ')  %(commentaire)
    if flag == 0 :
       return 0

    F = open (name ,"w")
    F.write ( txt )
    F.close()
    return 1


def recodetiret ( name ) :

    F = open (name , "r")
    txt = F.read()
    F.close()
    newtxt =''
    flag = 0
    tiret=' - '
    newtxt=string.replace(txt,tiret,'ZXYCABFED')


    # on remplace les formes correctes par une chane alatoire, qui n'a jusqu' nouvel ordre aucune chance d'etre dans un texte
    
    liste_des_tirets_fin=alterationsfinales('-')

    # on traite d'abord les formes du type -. ou -, et on spare les deux signes en ajoutant un espace
    
    for forme in liste_des_tirets_fin :
        if string.find(newtxt,forme) !=-1 :
            flag=1
            newtxt=string.replace(newtxt, forme, (' ' + forme[0]+ ' ' +forme[1]))
            print "J\'ai trouv un tiret suivi d'un signe de ponctuation"
    if flag==1 : newtxt=string.replace(newtxt,tiret,'ZXYCABFED')    
    
    liste_des_tirets_ini=alterationsinitiales('-')

    # on traite ensuite les formes du type ,- ou [- et on spare  nouveau les deux signes par un espace
    
    del liste_des_tirets_ini[0] # on ne traite pas la forme .- parce qu'on la trouve dans les abrviations de prnoms composs du type J.-P.
    for forme in liste_des_tirets_ini :
        if string.find(newtxt,forme) !=-1 :
            flag=1
            newtxt=string.replace(newtxt, forme, (forme[0]+' '+forme[1] +' '))
            print "J\'ai trouv un tiret prcd d'un signe de ponctuation"        
   

    if flag == 0 :
       return 0
    
    newtxt=string.replace(newtxt,'ZXYCABFED',tiret)

    # on retrouve les formes correctes
    
    newtxt=string.replace(newtxt,'  ',' ') # limination des doubles espaces gnrs par la procdure
    
    F = open (name ,"w")
    F.write ( newtxt )
    F.close()
    return 1


def balises_html (name) :
    
    F = open (name , "r")
    txt = F.read()
    F.close()
    newtxt =txt
    flag = 0
    for balise in Liste_des_balises :
        if string.find(newtxt, balise)!=-1 :
            flag=1
            newtxt=string.replace(newtxt,balise,'')
            print "J\'ai trouv une balise HTML et je l\'ai supprim"
    for accent in Liste_des_accents_html :
        forme_correcte = accent [0]
        forme_incorrecte = accent[1]
        if string.find(newtxt, forme_incorrecte)!=-1 :
            flag=1
            newtxt=string.replace(newtxt,forme_incorrecte,forme_correcte)
            print "J\'ai trouv un accent HTML et je l\'ai remplac par une forme correcte"
    for accent in Liste_des_marqueurs_genre :
        forme_correcte = accent [0]
        forme_incorrecte = accent[1]
        if string.find(newtxt, forme_incorrecte)!=-1 :
            flag=1
            newtxt=string.replace(newtxt,forme_incorrecte,forme_correcte)
            print "J\'ai trouv un marqueur de genre et je l\'ai remplac par une forme spare"

    if flag==0 : return 0
    newtxt=string.replace(newtxt,'  ',' ') # limination des doubles espaces gnrs par la procdure
    F = open (name ,"w")
    F.write ( newtxt )
    F.close()
    return 1

def nombres_morceaux (name) :
    
    F = open (name , "r")
    txt = F.readlines()
    F.close()
    flag_nombre=0
    flag = 0
    nombre=''
    newtxt=''
    newlines=[]
    for ligne in txt :
        newtxt=''
        nombre=''
        mots_txt=string.split(ligne)
        mots_txt.append(' ')
        for mot in mots_txt :
            flag_chiffres=0
            for lettre in mot :
                if lettre not in string.digits :
                    flag_chiffres=1
                    break
            if flag_chiffres==1 :
                if flag_nombre==0 :
                    newtxt=newtxt+mot+' '
                else :
                    flag_nombre=0
                    newtxt=newtxt+nombre+' '+mot+' '
                    nombre=''
            else :
                flag_nombre=1
                if nombre !='' :
                    flag=1
                    print "J\'ai trouv le nombre %s en morceaux et je l'ai recoll " %(nombre+mot)
                    ### deux nombres qui se suivent et qu'on assemble ci-dessous
                nombre=nombre+mot

        newtxt=string.rstrip(newtxt)
        if '.000' in newtxt :
            newtxt=string.replace(newtxt,'.000','000') ### cas particulier des milliers traites a l'anglaise
            flag=1
            print "J\'ai trouv des .000 et j'ai enlev le point"
        newlines.append(newtxt+'\n')
    if flag==0 : return 0
    F = open (name ,"w")
    F.writelines ( newlines )
    F.close()
    return 1

def traitement ():
            f = open(filename,"w")
            f.write ('fileCtx0005\n')
            if Titre:
                for i, contenu in enumerate(Titre):
                    f.write("{contenu}\n".format(contenu=contenu))
            else:
                f.write('\n')
            if Auteur:
                for i, contenu in enumerate(Auteur):
                    f.write("{contenu}\n".format(contenu=contenu))
            else:
                f.write('\n')
            if Narrateur:
                for i, contenu in enumerate(Narrateur):
                    f.write("{contenu}\n".format(contenu=contenu))
            else:
                f.write('\n')
            if Destinataire:
                for i, contenu in enumerate(Destinataire):
                    f.write("{contenu}\n".format(contenu=contenu))
            else:
                f.write('\n')
            if Date:
                for i, contenu in enumerate(Date):
                    f.write("{contenu}\n".format(contenu=contenu))
            else:
                f.write('\n')
            if Support:
                for i, contenu in enumerate(Support):
                    f.write("{contenu}\n".format(contenu=contenu))
            else:
                f.write('\n')
            if Tsupport:
                for i, contenu in enumerate(Tsupport):
                    f.write("{contenu}\n".format(contenu=contenu))
            else:
                f.write('\n')
            if Observation:
                for i, contenu in enumerate(Observation):
                    f.write("{contenu}\n".format(contenu=contenu))
            else:
                f.write('\n')
            if Stauteur:
                for i, contenu in enumerate(Stauteur):
                    f.write("{contenu}\n".format(contenu=contenu))
            else:
                f.write('\n')
            if Lieu:
                for i, contenu in enumerate(Lieu):
                    f.write("{contenu}\n".format(contenu=contenu))
            else:
                f.write('\n')
            if CL1:
                for i, contenu in enumerate(CL1):
                    f.write("{contenu}\n".format(contenu=contenu))
            else:
                f.write('\n')
            if CL2:
                for i, contenu in enumerate(CL2):
                    f.write("{contenu}".format(contenu=contenu))
            else:
                f.write('\n')
            f.write('\nn\nn\n')
            if Liens!='':
                f.write('REF_HEURE:00:00\n')
                for i, contenu in enumerate(Liens):
                    f.write("REF_EXT:{contenu}\n".format(contenu=contenu))
            else:
                f.write('\n')
            f.write('\n')
            f.close()
            return 1


Liste_fichiers=[]
base=os.getcwd()
list_dir=[base]
nb=0

while list_dir:
    base = list_dir.pop(0)
    for e in os.listdir(base):
        elem = os.path.join(base, e)
        if os.path.isdir(elem):
            list_dir.append(elem)
        elif os.path.isfile(elem) and os.path.splitext(elem)[1] in ('.ctx', '.CTX'): 
            Liste_fichiers.append(elem)

for filename in Liste_fichiers :
    Test=''
    Titre=''
    Auteur=''
    Narrateur=''
    Destinataire=''
    Date=''
    Observation=''
    Support=''
    Tsupport=''
    CL1=''
    CL2=''
    Liens=''
    f = open(filename, "r")
    CTX = f.read()
    f.close()
    Test=re.findall('fileCtx0005',CTX)
    if len (Test)==1:
        if Test [0]=='fileCtx0005':
            print "Le fichier", filename, "est dj au format PI" 
    else:
        print "\n", nb+1, "Traitement du fichier", filename
        Titre=re.findall('titre" type="CHAR" value="(.+?)"', CTX)
        Auteur=re.findall('"auteur" type="CHAR" value="(.+?)"', CTX)
        Narrateur=re.findall('narrateur" type="CHAR" value="(.+?)"', CTX)
        Destinataire=re.findall('destinataire" type="CHAR" value="(.+?)"', CTX)
        Date=re.findall('date" type="DATETIME" value="(.+?) ', CTX)
        Observation=re.findall('Observation" type="CHAR" value="(.+?)"', CTX)
        Support=re.findall('"support" type="CHAR" value="(.+?)"', CTX)
        Tsupport=re.findall('type de support" type="CHAR" value="(.+?)"', CTX)
        Stauteur=re.findall('statut auteur" type="CHAR" value="(.+?)"', CTX)
        Lieu=re.findall('mission" type="CHAR" value="(.+?)"', CTX)
        CL1=re.findall('champ libre 1" type="CHAR" value="(.+?)"', CTX)
        CL2=re.findall('champ libre 2" type="CHAR" value="(.+?)"', CTX)
        Liens=re.findall('<objet champ="liens" type="CHAR" value="(.+?)"', CTX)
        traitement ()
        n1 = recode (filename)
        n2 = recodetiret ( filename)
        n3=balises_html(filename)
        n4=nombres_morceaux(filename)
        nb = nb + max(n1,n2,n3,n4)
